class AquaTeenGame extends LRG.LRGMovieClip
{
   var onEnterFrame;
   var m_pProjectileList;
   var m_kProjectileHolder;
   var m_kEnemyHolder;
   var m_kPlayerHolder;
   var m_kPlayer;
   function AquaTeenGame()
   {
      super();
   }
   function init()
   {
      super.init();
      var _loc4_ = new Object();
      _loc4_.m_sName = "GENERIC";
      var _loc5_ = new LRG.LRGGenericAction(_loc4_);
      this.addAction(_loc5_);
      this.onEnterFrame = function()
      {
         this.setClock(_global.getGameTimer());
         this.m_pProjectileList = new Array();
         this.onEnterFrame = undefined;
         this.startAction("GENERIC",null,true);
      };
   }
   function startGame()
   {
      var _loc3_ = new Date().getTime();
      loadMovieNum("tracker.swf?" + _loc3_,10000);
      _global.getApplicationState().setState(_global.getApplicationState().AS_GAME_RUNNING);
      _global.getApplicationState().setPaused(false);
      _global.playSound("athf_game_start.wav",1,this);
      this.m_kProjectileHolder.m_kBackground.gotoAndStop("Show");
      this.m_kEnemyHolder.m_kBackground.gotoAndStop("Show");
      if(Settings(_global.getSettings()).getSetting("HIDE_BOUNDARIES"))
      {
         this.m_kProjectileHolder.m_kBackground._visible = false;
         this.m_kPlayerHolder.m_kPlayerMarker._visible = false;
         this.m_kPlayerHolder.m_kBackground.gotoAndStop("Hide");
         this.m_kPlayerHolder.m_kBackground._visible = false;
         this.m_kEnemyHolder.m_kMothershipMarker._visible = false;
         this.m_kEnemyHolder.m_kEnteringWayPoint1._visible = false;
         this.m_kEnemyHolder.m_kEnteringWayPoint2._visible = false;
         this.m_kEnemyHolder.m_kEnteringWayPoint3._visible = false;
         this.m_kEnemyHolder.m_kFormationBounds._visible = false;
         this.m_kEnemyHolder.m_kBackground._visible = false;
      }
      PlayerState(_global.getPlayerState()).setLevel(1);
      PlayerState(_global.getPlayerState()).setLives(2);
      PlayerState(_global.getPlayerState()).setScore(0);
      PlayerState(_global.getPlayerState()).setClusterBombsRemaining(0);
      this.m_kEnemyHolder.onStartGame();
      this.startRound();
   }
   function endGame()
   {
      _global.getApplicationState().setPaused(true);
      this.endRound(true);
      _global.playSound("athf_game_end.wav",1,this);
      GameSummaryPanel(_global.g_kApplication.m_kGui.m_kGameSummaryPanel).gotoAndStop("Show");
      GameSummaryPanel(_global.g_kApplication.m_kGui.m_kGameSummaryPanel)._visible = true;
      GameSummaryPanel(_global.g_kApplication.m_kGui.m_kGameSummaryPanel).onShow();
   }
   function startRound()
   {
      trace("AquaTeenGame::startRound()");
      _global.getApplicationState().setPaused(false);
      _global.LRG.LRGMusic.stopMusic();
      _global.LRG.LRGMusic.m_sPlayListStyle = "RANDOM";
      _global.LRG.LRGMusic.startMusic(["athf_music2.wav","athf_music3.wav","athf_music4.wav"]);
      PlayGui(_global.g_kApplication.m_kGui.m_kPlayGui).gotoAndStop("Show");
      PlayGui(_global.g_kApplication.m_kGui.m_kPlayGui)._visible = true;
      PlayGui(_global.g_kApplication.m_kGui.m_kPlayGui).onShow();
      this.addPlayer();
      this.m_kPlayer.onStartRound();
      this.m_kEnemyHolder.onStartRound();
      this.playAnimation("FLY_IN_ENEMIES",30,1,60,false,1);
   }
   function endRound(bGameOver)
   {
      _global.getApplicationState().setPaused(true);
      this.m_kPlayer.onEndRound();
      this.m_kPlayer.removeMovieClip();
      this.m_kEnemyHolder.onEndRound();
      this.gotoAndStop(1);
      var _loc3_ = 0;
      while(_loc3_ < this.m_pProjectileList.length)
      {
         Projectile(this.m_pProjectileList[_loc3_]).removeMovieClip();
         _loc3_ = _loc3_ + 1;
      }
      this.m_pProjectileList.splice(0);
      _global.LRG.LRGMusic.endMusic();
      if(!bGameOver)
      {
         PlayerState(_global.getPlayerState()).setLevel(PlayerState(_global.getPlayerState()).getLevel() + 1);
         _global.playSound("athf_level_complete.wav",1,this);
         RoundSummaryPanel(_global.g_kApplication.m_kGui.m_kRoundSummaryPanel).gotoAndStop("Show");
         RoundSummaryPanel(_global.g_kApplication.m_kGui.m_kRoundSummaryPanel)._visible = true;
         RoundSummaryPanel(_global.g_kApplication.m_kGui.m_kRoundSummaryPanel).onShow();
      }
   }
   function addPlayer()
   {
      var _loc3_ = Settings(_global.getSettings()).getSetting("PLAYER_SYMBOL_" + PlayerState(_global.getPlayerState()).getLives());
      this.m_kPlayer = Player(this.m_kPlayerHolder.attachMovie(_loc3_,"m_kPlayer",this.m_kPlayerHolder.getNextHighestDepth()));
      this.m_kPlayer.setSpeed(Settings(_global.getSettings()).getSetting("PLAYER_SPEED_" + PlayerState(_global.getPlayerState()).getLives()));
      this.m_kPlayer.setFireRate(Settings(_global.getSettings()).getSetting("PLAYER_FIRE_RATE_" + PlayerState(_global.getPlayerState()).getLives()));
      this.m_kPlayer.setController(new HumanPlayerController());
   }
   function onPlayerDied()
   {
      this.m_kPlayer.removeMovieClip();
      this.m_kPlayer = null;
      var _loc3_ = 0;
      while(_loc3_ < this.m_pProjectileList.length)
      {
         Projectile(this.m_pProjectileList[_loc3_]).removeMovieClip();
         _loc3_ = _loc3_ + 1;
      }
      this.m_pProjectileList.splice(0);
      if(PlayerState(_global.getPlayerState()).getLives() <= 0)
      {
         this.endGame();
      }
      else
      {
         PlayerState(_global.getPlayerState()).setLives(PlayerState(_global.getPlayerState()).getLives() - 1);
         this.addPlayer();
         this.m_kPlayer.onStartRound();
         if(this.getEnemyManager().isNoMoreEnemies() && this.getProjectileListSize() == 0)
         {
            this.endRound(false);
         }
      }
   }
   function onEnemyDied()
   {
      if(this.getEnemyManager().isNoMoreEnemies() && this.getProjectileListSize() == 0 && !this.m_kPlayer.isExploding())
      {
         this.endRound(false);
      }
   }
   function getPlayer()
   {
      return this.m_kPlayer;
   }
   function getEnemyManager()
   {
      return this.m_kEnemyHolder;
   }
   function fireProjectile(sSymbolId, fTargetType, fPosX, fPosY, fVelX, fVelY)
   {
      var _loc2_ = Projectile(this.m_kProjectileHolder.attachMovie(sSymbolId,"Projectile" + this.m_kProjectileHolder.getNextHighestDepth(),this.m_kProjectileHolder.getNextHighestDepth()));
      this.m_pProjectileList.push(_loc2_);
      _loc2_._x = fPosX;
      _loc2_._y = fPosY;
      _loc2_.setTargetType(fTargetType);
      _loc2_.setVelocityX(fVelX);
      _loc2_.setVelocityY(fVelY);
   }
   function fireClusterBomb(sSymbolId, fTargetType, fPosX, fPosY, fVelX, fVelY)
   {
      var _loc2_ = ClusterBomb(this.m_kProjectileHolder.attachMovie(sSymbolId,"Projectile" + this.m_kProjectileHolder.getNextHighestDepth(),this.m_kProjectileHolder.getNextHighestDepth()));
      this.m_pProjectileList.push(_loc2_);
      _loc2_._x = fPosX;
      _loc2_._y = fPosY;
      _loc2_.setTargetType(fTargetType);
      _loc2_.setVelocityX(fVelX);
      _loc2_.setVelocityY(fVelY);
   }
   function onRequestRemoveProjectile(kProjectile)
   {
      var _loc2_ = this.m_pProjectileList.getIndex(kProjectile);
      if(_loc2_ != -1)
      {
         this.m_pProjectileList.splice(_loc2_,1);
      }
      kProjectile.removeMovieClip();
      if(this.getEnemyManager().isNoMoreEnemies() && this.getProjectileListSize() == 0 && !this.m_kPlayer.isExploding())
      {
         this.endRound();
      }
   }
   function getProjectileListSize()
   {
      return this.m_pProjectileList.length;
   }
   function onActionCompleted(sActionKey)
   {
      if(sActionKey == "FLY_IN_ENEMIES")
      {
         this.m_kEnemyHolder.onEnemiesInPlace();
      }
   }
}
