class Enemy extends LRG.LRGMovieClip
{
   var m_sDestinationId;
   var m_fPointValue;
   var m_bMothership;
   var m_bInvertPath;
   var m_fDestinationX;
   var m_fDestinationY;
   var m_fSpeed;
   function Enemy()
   {
      super();
   }
   function init()
   {
      super.init();
      this.setClock(_global.getGameTimer());
      this.m_sDestinationId = undefined;
      this.m_fPointValue = 0;
      this.m_bMothership = false;
      this.m_bInvertPath = false;
   }
   function onStartGame()
   {
   }
   function onStartRound()
   {
   }
   function onEndRound()
   {
   }
   function setDestination(sDestId, fDestX, fDestY)
   {
      this.m_sDestinationId = sDestId;
      this.m_fDestinationX = fDestX;
      this.m_fDestinationY = fDestY;
      if(this.m_bInvertPath)
      {
         this.m_fDestinationX = 600 - this.m_fDestinationX;
      }
      var _loc2_ = new Object();
      _loc2_.m_sName = "MOVE_TO_DESTINATION";
      _loc2_.m_fFPS = 45;
      _loc2_.m_fSpeed = this.m_fSpeed;
      _loc2_.m_kGoal = {x:this.m_fDestinationX,y:this.m_fDestinationY};
      var _loc3_ = new LRG.LRGMoveAction(_loc2_);
      this.addAction(_loc3_);
      this.startAction("MOVE_TO_DESTINATION",null,true);
   }
   function getDestinationId()
   {
      return this.m_sDestinationId;
   }
   function getDestinationX()
   {
      return this.m_fDestinationX;
   }
   function getDestinationY()
   {
      return this.m_fDestinationY;
   }
   function isDestinationReached()
   {
      return this.getActiveActions().getIndex("MOVE_TO_DESTINATION") != -1;
   }
   function setSpeed(fSpeed)
   {
      this.m_fSpeed = fSpeed;
   }
   function getSpeed()
   {
      return this.m_fSpeed;
   }
   function setPointValue(fPointValue)
   {
      this.m_fPointValue = fPointValue;
   }
   function getPointValue()
   {
      return this.m_fPointValue;
   }
   function setMothership(bMothership)
   {
      this.m_bMothership = bMothership;
      if(this.m_bMothership)
      {
         var _loc3_ = {x:this._x,y:this._y};
         this._parent.localToGlobal(_loc3_);
         var _loc4_ = _loc3_.x / 3 - 100;
         _global.playSound("athf_mothership.wav",9999,this,_loc4_);
         this.doEnterFrame = function()
         {
            var _loc2_ = {x:this._x,y:this._y};
            this._parent.localToGlobal(_loc2_);
            var _loc3_ = _loc2_.x / 3 - 100;
            var _loc4_ = new Sound(this);
            _loc4_.setPan(_loc3_);
         };
      }
   }
   function isMothership()
   {
      return this.m_bMothership;
   }
   function setInvertPath(bInvertPath)
   {
      this.m_bInvertPath = bInvertPath;
   }
   function isInvertPath()
   {
      return this.m_bInvertPath;
   }
   function explode()
   {
      PlayerState(_global.getPlayerState()).setScore(PlayerState(_global.getPlayerState()).getScore() + this.getPointValue());
      var _loc3_ = {x:this._x,y:this._y};
      this._parent.localToGlobal(_loc3_);
      var _loc4_ = _loc3_.x / 3 - 100;
      _global.playSound("athf_mooninite_hit.wav",1,this,_loc4_);
      if(this.isMothership())
      {
         _loc3_ = {x:this._x,y:this._y};
         this._parent.localToGlobal(_loc3_);
         _loc4_ = _loc3_.x / 3 - 100;
         var _loc5_ = new Sound(this);
         _loc5_.stop("athf_mothership.wav");
         _global.playSound("athf_mothership_drop.wav",1,this,_loc4_);
         var _loc6_ = _global.g_kApplication.m_kGameScreen;
         _loc6_.fireProjectile("s_ClusterPowerup",Projectile.TARGET_PLAYER,this._x,this._y + this._height,0,Settings(_global.getSettings()).getSettingForLevel("POWERUP_SPEED"));
      }
      this.playAnimation("EXPLODE",38,41,59,false,1);
   }
   function isExploding()
   {
      return this.getActiveActions().getIndex("EXPLODE") != -1;
   }
   function onRequestFireProjectile(fForce)
   {
      var _loc3_ = _global.g_kApplication.m_kGameScreen;
      var _loc4_ = this.getBounds(_loc3_);
      _loc3_.fireProjectile("s_EnemyMissile",Projectile.TARGET_PLAYER,this._x,_loc4_.yMax,0,fForce);
   }
   function onActionCompleted(sActionKey)
   {
      if(sActionKey == "EXPLODE")
      {
         AquaTeenGame(_global.g_kApplication.m_kGameScreen).getEnemyManager().onRequestRemoveEnemy(this);
         AquaTeenGame(_global.g_kApplication.m_kGameScreen).onEnemyDied();
      }
      else if(sActionKey == "MOVE_TO_DESTINATION")
      {
         AquaTeenGame(_global.g_kApplication.m_kGameScreen).getEnemyManager().onReachedDestination(this,this.m_sDestinationId);
      }
   }
}
