class EnemyManager extends LRG.LRGMovieClip
{
   var m_kFormation;
   var m_kReplacementEnemy;
   var m_kMothership;
   var m_pFormationArray;
   var m_fCeaseFireTime;
   var onEnterFrame;
   var m_fFormationX;
   var m_fFormationY;
   var m_fLastUpdateTime;
   var m_kEnteringWayPoint1;
   var m_kBackground;
   var m_kMothershipMarker;
   var m_kEnteringWayPoint2;
   var m_kEnteringWayPoint3;
   var m_kFormationBounds;
   var m_fFormationGoalX;
   var m_fFormationGoalY;
   var m_fFormationSpeed;
   var m_fFormationCosine;
   var m_fFormationSine;
   function EnemyManager()
   {
      super();
   }
   function init()
   {
      super.init();
      this.m_kFormation = undefined;
      this.m_kReplacementEnemy = undefined;
      this.m_kMothership = undefined;
      this.m_pFormationArray = new Array();
      this.m_fCeaseFireTime = 0;
      var _loc3_ = new Object();
      _loc3_.m_sName = "FORMATION_FIRE";
      _loc3_.m_fSPF = 10;
      _loc3_.m_kCallback = this.formationFireCallback;
      var _loc8_ = new LRG.LRGRepeatedCallbackAction(_loc3_);
      this.addAction(_loc8_);
      var _loc5_ = new Object();
      _loc5_.m_sName = "FORMATION_REPLACE";
      _loc5_.m_fSPF = 5;
      _loc5_.m_kCallback = this.formationReplaceCallback;
      var _loc7_ = new LRG.LRGRepeatedCallbackAction(_loc5_);
      this.addAction(_loc7_);
      var _loc4_ = new Object();
      _loc4_.m_sName = "ADD_MOTHERSHIP";
      _loc4_.m_fTotalActionTime = 15;
      _loc4_.m_kCallback = this.addMothershipCallback;
      var _loc6_ = new LRG.LRGDelayedCallbackAction(_loc4_);
      this.addAction(_loc6_);
   }
   function onStartGame()
   {
   }
   function onStartRound()
   {
      var _loc4_ = _global.g_kApplication.m_kGameScreen;
      this.m_kFormation = this.attachMovie("s_Formation" + ((PlayerState(_global.getPlayerState()).getLevel() - 1) % 10 + 1),"m_kFormationLayout",this.getNextHighestDepth());
      trace("s_Formation" + ((PlayerState(_global.getPlayerState()).getLevel() - 1) % 10 + 1));
      this.m_kFormation._visible = false;
      for(var _loc3_ in this.m_kFormation)
      {
         this.m_kFormation[_loc3_].onEnterFrame = function()
         {
            AquaTeenGame(_global.g_kApplication.m_kGameScreen).getEnemyManager().addFormationEnemy(this);
            this.onEnterFrame = undefined;
         };
      }
      this.m_fFormationX = this.m_kFormation._x;
      this.m_fFormationY = this.m_kFormation._y;
   }
   function onEnemiesInPlace()
   {
      var _loc3_ = new Object();
      _loc3_.m_fSPF = Math.max(Settings(_global.getSettings()).getSetting("FORMATION_FIRE_RATE_MIN"),Settings(_global.getSettings()).getSettingForLevel("FORMATION_FIRE_RATE"));
      this.startAction("FORMATION_FIRE",_loc3_,false);
      var _loc5_ = new Object();
      _loc5_.m_fSPF = Math.max(Settings(_global.getSettings()).getSetting("FORMATION_REPLACEMENT_RATE_MIN"),Settings(_global.getSettings()).getSettingForLevel("FORMATION_REPLACEMENT_RATE"));
      this.startAction("FORMATION_REPLACE",_loc5_,false);
      var _loc4_ = new Object();
      _loc4_.m_fTotalActionTime = Settings(_global.getSettings()).getSettingForLevel("MOTHERSHIP_FREQUENCY");
      this.startAction("ADD_MOTHERSHIP",_loc4_,false);
      this.m_fLastUpdateTime = LRG.Utils.LRGGameTimer(_global.getGameTimer()).getTime();
      this.setFormationGoal();
   }
   function onEndRound()
   {
      this.stopAction("FORMATION_FIRE");
      this.stopAction("FORMATION_REPLACE");
      this.stopAction("ADD_MOTHERSHIP");
      this.m_kFormation.removeMovieClip();
      this.m_kFormation = undefined;
      var _loc2_ = 0;
      while(_loc2_ < this.m_pFormationArray.length)
      {
         Enemy(this.m_pFormationArray[_loc2_]).removeMovieClip();
         _loc2_ = _loc2_ + 1;
      }
      this.m_pFormationArray.splice(0);
      if(this.m_kReplacementEnemy)
      {
         this.m_kReplacementEnemy.removeMovieClip();
         this.m_kReplacementEnemy = null;
      }
      if(this.m_kMothership)
      {
         var _loc3_ = new Sound(this.m_kMothership);
         _loc3_.stop("athf_mothership.wav");
         this.m_kMothership.removeMovieClip();
         this.m_kMothership = null;
      }
   }
   function isNoMoreEnemies()
   {
      return !this.m_kMothership && !this.m_kReplacementEnemy && this.m_pFormationArray.length <= 0;
   }
   function checkCollision(kProjectile, bClusterExplosion)
   {
      if(bClusterExplosion)
      {
         var _loc4_ = new Array();
         if(this.m_kMothership)
         {
            if(this.m_kMothership.hitTest(kProjectile))
            {
               if(!this.m_kMothership.isExploding())
               {
                  _loc4_.push(this.m_kMothership);
               }
            }
         }
         if(this.m_kReplacementEnemy)
         {
            if(this.m_kReplacementEnemy.hitTest(kProjectile))
            {
               if(!this.m_kReplacementEnemy.isExploding())
               {
                  _loc4_.push(this.m_kReplacementEnemy);
               }
            }
         }
         var _loc2_ = 0;
         while(_loc2_ < this.m_pFormationArray.length)
         {
            if(this.m_pFormationArray[_loc2_].hitTest(kProjectile))
            {
               if(!Enemy(this.m_pFormationArray[_loc2_]).isExploding())
               {
                  _loc4_.push(this.m_pFormationArray[_loc2_]);
               }
            }
            _loc2_ = _loc2_ + 1;
         }
         return _loc4_;
      }
      if(ClusterBomb(kProjectile))
      {
         if(this.m_kMothership)
         {
            if(this.m_kMothership.hitTest(kProjectile))
            {
               if(!this.m_kMothership.isExploding())
               {
                  return this.m_kMothership;
               }
            }
         }
         if(this.m_kReplacementEnemy)
         {
            if(this.m_kReplacementEnemy.hitTest(kProjectile))
            {
               if(!this.m_kReplacementEnemy.isExploding())
               {
                  return this.m_kReplacementEnemy;
               }
            }
         }
         _loc2_ = 0;
         while(_loc2_ < this.m_pFormationArray.length)
         {
            if(this.m_pFormationArray[_loc2_].hitTest(kProjectile))
            {
               if(!Enemy(this.m_pFormationArray[_loc2_]).isExploding())
               {
                  return this.m_pFormationArray[_loc2_];
               }
            }
            _loc2_ = _loc2_ + 1;
         }
      }
      else
      {
         if(this.m_kMothership)
         {
            if(this.m_kMothership.hitTest(kProjectile._x,kProjectile._y,false))
            {
               if(!this.m_kMothership.isExploding())
               {
                  return this.m_kMothership;
               }
            }
         }
         if(this.m_kReplacementEnemy)
         {
            if(this.m_kReplacementEnemy.hitTest(kProjectile._x,kProjectile._y,false))
            {
               if(!this.m_kReplacementEnemy.isExploding())
               {
                  return this.m_kReplacementEnemy;
               }
            }
         }
         _loc2_ = 0;
         while(_loc2_ < this.m_pFormationArray.length)
         {
            if(this.m_pFormationArray[_loc2_].hitTest(kProjectile._x,kProjectile._y,false))
            {
               if(!Enemy(this.m_pFormationArray[_loc2_]).isExploding())
               {
                  return this.m_pFormationArray[_loc2_];
               }
            }
            _loc2_ = _loc2_ + 1;
         }
      }
      return null;
   }
   function addFormationEnemy(kGuide)
   {
      var _loc5_ = _global.g_kApplication.m_kGameScreen;
      var _loc3_ = Enemy(this.attachMovie(kGuide.getSymbolName(),kGuide._name,this.getNextHighestDepth()));
      _loc3_._x = kGuide._x;
      _loc3_._y = kGuide._y;
      _loc3_.setPointValue(kGuide.getPointValue());
      this.m_pFormationArray.push(_loc3_);
   }
   function addReplacementEnemy(kGuide)
   {
      this.m_kReplacementEnemy = Enemy(this.attachMovie(kGuide.getSymbolName(),kGuide._name,this.getNextHighestDepth()));
      this.m_kReplacementEnemy.setInvertPath(Math.random() >= 0.5);
      if(this.m_kReplacementEnemy.isInvertPath())
      {
         this.m_kReplacementEnemy._x = 600 - this.m_kEnteringWayPoint1._x;
      }
      else
      {
         this.m_kReplacementEnemy._x = this.m_kEnteringWayPoint1._x;
      }
      this.m_kReplacementEnemy._y = - this.m_kReplacementEnemy._height;
      this.m_kReplacementEnemy.setSpeed(Settings(_global.getSettings()).getSettingForLevel("FORMATION_REPLACEMENT_SPEED"));
      this.m_kReplacementEnemy.setPointValue(kGuide.getPointValue());
      this.m_kReplacementEnemy.setDestination("m_kEnteringWayPoint1",this.m_kEnteringWayPoint1._x,this.m_kEnteringWayPoint1._y);
   }
   function addMothershipCallback()
   {
      if(this.m_kMothership || this.isNoMoreEnemies())
      {
         return undefined;
      }
      var _loc3_ = this.m_kBackground.getBounds(this);
      this.m_kMothership = Enemy(this.attachMovie("s_EnemyMothership","m_kMothership",this.getNextHighestDepth()));
      this.m_kMothership._x = _loc3_.xMax + this.m_kMothership._width;
      this.m_kMothership._y = this.m_kMothershipMarker._y;
      this.m_kMothership.setMothership(true);
      this.m_kMothership.setSpeed(Settings(_global.getSettings()).getSettingForLevel("MOTHERSHIP_SPEED"));
      this.m_kMothership.setPointValue(Settings(_global.getSettings()).getSetting("MOTHERSHIP_POINT_VALUE"));
      this.m_kMothership.setDestination("",_loc3_.xMin - this.m_kMothership._width,this.m_kMothershipMarker._y);
   }
   function formationReplaceCallback()
   {
      if(this.m_kReplacementEnemy || this.isNoMoreEnemies())
      {
         return undefined;
      }
      for(var _loc2_ in this.m_kFormation)
      {
         if(EnemyGuide(this.m_kFormation[_loc2_]) && !this[_loc2_])
         {
            this.addReplacementEnemy(this.m_kFormation[_loc2_]);
            return undefined;
         }
      }
   }
   function formationFireCallback()
   {
      if(this.getClipTime() - this.m_fCeaseFireTime < 1.75 || AquaTeenGame(_global.g_kApplication.m_kGameScreen).getPlayer().isExploding() || !AquaTeenGame(_global.g_kApplication.m_kGameScreen).getPlayer())
      {
         return undefined;
      }
      var _loc8_ = Settings(_global.getSettings()).getSettingForLevel("FORMATION_MIN_NUM_FIRING");
      var _loc11_ = Settings(_global.getSettings()).getSettingForLevel("FORMATION_MAX_NUM_FIRING");
      var _loc7_ = Math.floor(Math.random() * (_loc11_ - _loc8_ + 1)) + _loc8_;
      var _loc5_ = this.m_pFormationArray.slice();
      var _loc4_ = new Array();
      while(_loc4_.length < _loc7_ && _loc5_.length > 0)
      {
         var _loc6_ = Math.floor(Math.random() * _loc5_.length);
         if(!Enemy(_loc5_[_loc6_]).isExploding())
         {
            _loc4_.push(_loc5_[_loc6_]);
         }
         _loc5_.splice(_loc6_,1);
      }
      var _loc3_ = 0;
      while(_loc3_ < _loc4_.length)
      {
         _loc4_[_loc3_].onRequestFireProjectile(Settings(_global.getSettings()).getSettingForLevel("ENEMY_FIRE_FORCE"));
         var _loc9_ = {x:_loc4_[_loc3_]._x,y:_loc4_[_loc3_]._y};
         _loc4_[_loc3_]._parent.localToGlobal(_loc9_);
         var _loc10_ = _loc9_.x / 3 - 100;
         _global.playSound("athf_mooninite_fire.wav",1,_loc4_[_loc3_],_loc10_);
         _loc3_ = _loc3_ + 1;
      }
      false;
      false;
      if(this.m_kReplacementEnemy && !this.m_kReplacementEnemy.isExploding())
      {
         this.m_kReplacementEnemy.onRequestFireProjectile(Settings(_global.getSettings()).getSettingForLevel("FORMATION_REPLACEMENT_FIRE_FORCE"));
         _loc9_ = {x:this.m_kReplacementEnemy._x,y:this.m_kReplacementEnemy._y};
         this.m_kReplacementEnemy._parent.localToGlobal(_loc9_);
         _loc10_ = _loc9_.x / 3 - 100;
         _global.playSound("athf_mooninite_fire.wav",1,this.m_kReplacementEnemy,_loc10_);
      }
   }
   function ceaseFire()
   {
      this.m_fCeaseFireTime = this.getClipTime();
   }
   function onRequestRemoveEnemy(kEnemy)
   {
      var _loc3_ = this.m_pFormationArray.getIndex(kEnemy);
      if(_loc3_ != -1)
      {
         this.m_pFormationArray.splice(_loc3_,1);
         kEnemy.removeMovieClip();
      }
      if(kEnemy == this.m_kReplacementEnemy)
      {
         this.m_kReplacementEnemy.removeMovieClip();
         this.m_kReplacementEnemy = null;
      }
      if(kEnemy == this.m_kMothership)
      {
         var _loc4_ = new Sound(this.m_kMothership);
         _loc4_.stop("athf_mothership.wav");
         this.m_kMothership.removeMovieClip();
         this.m_kMothership = null;
         this.startAction("ADD_MOTHERSHIP",null,false);
      }
   }
   function onReachedDestination(kEnemy, sDestinationId)
   {
      if(kEnemy == this.m_kMothership)
      {
         var _loc9_ = new Sound(this.m_kMothership);
         _loc9_.stop("athf_mothership.wav");
         this.m_kMothership.removeMovieClip();
         this.m_kMothership = null;
         this.startAction("ADD_MOTHERSHIP",null,false);
         AquaTeenGame(_global.g_kApplication.m_kGameScreen).onEnemyDied();
      }
      else if(sDestinationId == "m_kEnteringWayPoint1")
      {
         kEnemy.setDestination("m_kEnteringWayPoint2",this.m_kEnteringWayPoint2._x,this.m_kEnteringWayPoint2._y);
      }
      else if(sDestinationId == "m_kEnteringWayPoint2")
      {
         kEnemy.setDestination("m_kEnteringWayPoint3",this.m_kEnteringWayPoint3._x,this.m_kEnteringWayPoint3._y);
      }
      else if(sDestinationId == "m_kEnteringWayPoint3")
      {
         var _loc6_ = this.m_kFormation[kEnemy._name];
         var _loc5_ = this.m_fFormationX + _loc6_._x;
         kEnemy.setInvertPath(false);
         kEnemy.setDestination("Formation",_loc5_,this.m_kEnteringWayPoint3._y);
      }
      else if(sDestinationId == "Formation")
      {
         _loc6_ = this.m_kFormation[kEnemy._name];
         _loc5_ = this.m_fFormationX + _loc6_._x;
         var _loc4_ = this.m_fFormationY + _loc6_._y;
         var _loc8_ = _global.LRG.Utils.Vector2D.magnitude(_loc5_ - kEnemy._x,_loc4_ - kEnemy._y);
         if(_loc8_ >= 2)
         {
            this.m_kReplacementEnemy.setDestination("Formation",_loc5_,_loc4_);
         }
         else
         {
            this.m_pFormationArray.push(this.m_kReplacementEnemy);
            this.m_kReplacementEnemy = null;
         }
      }
   }
   function setFormationGoal()
   {
      var _loc13_ = _global.g_kApplication.m_kGameScreen;
      var _loc3_ = new Object();
      if(this.m_pFormationArray.length > 0)
      {
         _loc3_.xMin = Infinity;
         _loc3_.xMax = - Infinity;
         _loc3_.yMin = Infinity;
         _loc3_.yMax = - Infinity;
         var _loc5_ = 0;
         while(_loc5_ < this.m_pFormationArray.length)
         {
            var _loc4_ = this.m_pFormationArray[_loc5_].getBounds(this);
            if(_loc4_.xMin < _loc3_.xMin)
            {
               _loc3_.xMin = _loc4_.xMin;
            }
            if(_loc4_.xMax > _loc3_.xMax)
            {
               _loc3_.xMax = _loc4_.xMax;
            }
            if(_loc4_.yMin < _loc3_.yMin)
            {
               _loc3_.yMin = _loc4_.yMin;
            }
            if(_loc4_.yMax > _loc3_.yMax)
            {
               _loc3_.yMax = _loc4_.yMax;
            }
            _loc5_ = _loc5_ + 1;
         }
      }
      else
      {
         _loc3_ = this.m_kFormation.getBounds(this);
      }
      var _loc6_ = this.m_kFormationBounds.getBounds(this);
      var _loc8_ = _loc6_.xMax - _loc6_.xMin - (_loc3_.xMax - _loc3_.xMin);
      var _loc7_ = _loc6_.yMax - _loc6_.yMin - (_loc3_.yMax - _loc3_.yMin);
      var _loc10_ = this.m_fFormationGoalX;
      var _loc9_ = this.m_fFormationGoalY;
      while(true)
      {
         this.m_fFormationGoalX = Math.random() * _loc8_ + _loc6_.xMin + (this.m_fFormationX - _loc3_.xMin);
         this.m_fFormationGoalY = Math.random() * _loc7_ + _loc6_.yMin + (this.m_fFormationY - _loc3_.yMin);
         if(_global.LRG.Utils.Vector2D.magnitude(_loc10_ - this.m_fFormationGoalX,_loc9_ - this.m_fFormationGoalY) >= _global.LRG.Utils.Vector2D.magnitude(_loc8_,_loc7_) / 5)
         {
            break;
         }
      }
      this.m_fFormationSpeed = Settings(_global.getSettings()).getSettingForLevel("FORMATION_SPEED");
      var _loc11_ = new Object();
      _loc11_.x = this.m_fFormationGoalX - this.m_fFormationX;
      _loc11_.y = this.m_fFormationGoalY - this.m_fFormationY;
      var _loc12_ = Math.atan2(_loc11_.y,_loc11_.x);
      this.m_fFormationCosine = Math.cos(_loc12_);
      this.m_fFormationSine = Math.sin(_loc12_);
      false;
   }
   function doEnterFrame()
   {
      if(ApplicationState(_global.getApplicationState()).isPaused())
      {
         return undefined;
      }
      var _loc7_ = LRG.Utils.LRGGameTimer(_global.getGameTimer()).getTime() - this.m_fLastUpdateTime;
      if(this.m_kFormation != undefined)
      {
         var _loc4_ = new Object();
         _loc4_.x = this.m_fFormationGoalX - this.m_fFormationX;
         _loc4_.y = this.m_fFormationGoalY - this.m_fFormationY;
         if(this.m_fFormationX == this.m_fFormationGoalX && this.m_fFormationY == this.m_fFormationGoalY)
         {
            this.setFormationGoal();
         }
         else
         {
            var _loc5_ = _loc7_ * this.m_fFormationSpeed;
            var _loc6_ = Math.sqrt(Math.pow(_loc4_.x,2) + Math.pow(_loc4_.y,2));
            if(_loc5_ >= _loc6_)
            {
               this.m_fFormationX = this.m_fFormationGoalX;
               this.m_fFormationY = this.m_fFormationGoalY;
               this.setFormationGoal();
            }
            else
            {
               this.m_fFormationX += _loc5_ * this.m_fFormationCosine;
               this.m_fFormationY += _loc5_ * this.m_fFormationSine;
            }
         }
         var _loc3_ = 0;
         while(_loc3_ < this.m_pFormationArray.length)
         {
            this.m_pFormationArray[_loc3_]._x = this.m_fFormationX + this.m_kFormation[this.m_pFormationArray[_loc3_]._name]._x;
            this.m_pFormationArray[_loc3_]._y = this.m_fFormationY + this.m_kFormation[this.m_pFormationArray[_loc3_]._name]._y;
            _loc3_ = _loc3_ + 1;
         }
      }
      this.m_fLastUpdateTime = LRG.Utils.LRGGameTimer(_global.getGameTimer()).getTime();
   }
}
