class Player extends LRG.LRGMovieClip
{
   var m_bFiring;
   var m_bExploding;
   var m_kController;
   var m_fVelocityX;
   var m_fLastUpdateTime;
   var m_fLastProjectileTime;
   var m_fLastClusterTime;
   var m_bNormalAnimation;
   var m_fSpeed;
   var m_fFireRate;
   var m_kEmitPoint;
   function Player()
   {
      super();
   }
   function init()
   {
      super.init();
      this.setClock(_global.getGameTimer());
      var _loc4_ = new Object();
      _loc4_.m_sName = "GENERIC";
      _loc4_.m_fFPS = 120;
      var _loc5_ = new LRG.LRGGenericAction(_loc4_);
      this.addAction(_loc5_);
      this.m_bFiring = false;
      this.m_bExploding = false;
      this.m_kController = undefined;
      this.m_fVelocityX = 0;
      this.m_fLastUpdateTime = this.getClipTime();
      this.m_fLastProjectileTime = this.getClipTime();
      this.m_fLastClusterTime = this.getClipTime();
   }
   function onStartRound()
   {
      this.m_fLastUpdateTime = this.getClipTime();
      this.m_fLastProjectileTime = this.getClipTime();
      this.m_fLastClusterTime = this.getClipTime();
      this.m_bFiring = false;
      this.m_bExploding = false;
      this.startAction("GENERIC",null,true);
      this.playAnimation("NORMAL",8,1,10,true,1);
      this.m_bNormalAnimation = true;
      this.m_kController.onStartRound();
      this._x = AquaTeenGame(_global.g_kApplication.m_kGameScreen).m_kPlayerHolder.m_kPlayerMarker._x;
      this._y = AquaTeenGame(_global.g_kApplication.m_kGameScreen).m_kPlayerHolder.m_kPlayerMarker._y;
      AquaTeenGame(_global.g_kApplication.m_kGameScreen).getEnemyManager().ceaseFire();
   }
   function onEndRound()
   {
      this.m_kController.onEndRound();
      this.stopAction("GENERIC",false);
   }
   function setController(kController)
   {
      this.m_kController = kController;
      this.m_kController.setPlayer(this);
   }
   function setVelocityX(fVel)
   {
      this.m_fVelocityX = fVel;
   }
   function getVelocityX()
   {
      return this.m_fVelocityX;
   }
   function setSpeed(fSpeed)
   {
      this.m_fSpeed = fSpeed;
   }
   function getSpeed()
   {
      return this.m_fSpeed;
   }
   function setFireRate(fFireRate)
   {
      this.m_fFireRate = fFireRate;
   }
   function getFireRate()
   {
      return this.m_fFireRate;
   }
   function onRequestMoveLeft()
   {
      if(this.isExploding())
      {
         return undefined;
      }
      if(this.getVelocityX() >= 0)
      {
         if(!this.m_bExploding)
         {
            this._xscale = - Math.abs(this._xscale);
            if(!this.m_bFiring)
            {
               this.playAnimation("WALK",30,91,120,true,1);
               this.m_bNormalAnimation = false;
            }
         }
      }
      this.setVelocityX(- this.m_fSpeed);
   }
   function onRequestMoveRight()
   {
      if(this.isExploding())
      {
         return undefined;
      }
      if(this.getVelocityX() <= 0)
      {
         if(!this.m_bExploding)
         {
            this._xscale = Math.abs(this._xscale);
            if(!this.m_bFiring)
            {
               this.playAnimation("WALK",30,91,120,true,1);
               this.m_bNormalAnimation = false;
            }
         }
      }
      this.setVelocityX(this.m_fSpeed);
   }
   function onRequestStop()
   {
      if(!this.m_bFiring && !this.m_bExploding && !this.m_bNormalAnimation)
      {
         this.playAnimation("NORMAL",8,1,10,true,1);
         this.m_bNormalAnimation = true;
      }
      this.setVelocityX(0);
   }
   function onRequestFireProjectile()
   {
      if(this.isExploding())
      {
         return undefined;
      }
      if(AquaTeenGame(_global.g_kApplication.m_kGameScreen).getEnemyManager().isNoMoreEnemies())
      {
         return undefined;
      }
      var _loc14_ = this.getClipTime() - this.m_fLastProjectileTime;
      if(_loc14_ > 1 / this.m_fFireRate)
      {
         this.m_bFiring = true;
         this.m_bNormalAnimation = false;
         this.playAnimation("FIRE",70,61,90,false,1);
         this.m_fLastProjectileTime = this.getClipTime();
         var _loc5_ = _global.g_kApplication.m_kGameScreen;
         var _loc15_ = this.getBounds(_loc5_);
         var _loc7_ = PlayerState(_global.getPlayerState()).getLives();
         var _loc6_ = Settings(_global.getSettings()).getSetting("PLAYER_FIRE_SYMBOL_" + _loc7_);
         var _loc4_ = Settings(_global.getSettings()).getSetting("PLAYER_FIRE_FORCE_" + _loc7_);
         var _loc3_ = {x:this.m_kEmitPoint._x,y:this.m_kEmitPoint._y};
         this.localToGlobal(_loc3_);
         if(_loc7_ >= 2)
         {
            var _loc9_ = {x:this._x,y:this._y};
            this._parent.localToGlobal(_loc9_);
            var _loc13_ = _loc9_.x / 3 - 100;
            _global.playSound("athf_meatwad_fire.wav",1,this,_loc13_);
            _loc5_.fireProjectile(_loc6_,Projectile.TARGET_ENEMIES,_loc3_.x,_loc3_.y,0,- _loc4_);
         }
         else if(_loc7_ >= 1)
         {
            _loc9_ = {x:this._x,y:this._y};
            this._parent.localToGlobal(_loc9_);
            _loc13_ = _loc9_.x / 3 - 100;
            _global.playSound("athf_mastershake_fire.wav",1,this,_loc13_);
            _loc5_.fireProjectile(_loc6_,Projectile.TARGET_ENEMIES,_loc3_.x,_loc3_.y,0,- _loc4_);
            var _loc8_ = Settings(_global.getSettings()).getSetting("PLAYER_FIRE_ANGLE_" + _loc7_);
            var _loc10_ = Math.cos(_loc8_);
            var _loc12_ = Math.sin(_loc8_);
            _loc5_.fireProjectile(_loc6_,Projectile.TARGET_ENEMIES,_loc3_.x,_loc3_.y,_loc10_ * _loc4_,(- _loc12_) * _loc4_);
            _loc5_.fireProjectile(_loc6_,Projectile.TARGET_ENEMIES,_loc3_.x,_loc3_.y,(- _loc10_) * _loc4_,(- _loc12_) * _loc4_);
         }
         else
         {
            _loc9_ = {x:this._x,y:this._y};
            this._parent.localToGlobal(_loc9_);
            _loc13_ = _loc9_.x / 3 - 100;
            _global.playSound("athf_frylock_fire.wav",1,this,_loc13_);
            var _loc11_ = Settings(_global.getSettings()).getSetting("PLAYER_FIRE_DIST_0");
            _loc5_.fireProjectile(_loc6_,Projectile.TARGET_ENEMIES,_loc3_.x - _loc11_ / 2,_loc3_.y,0,- _loc4_);
            _loc5_.fireProjectile(_loc6_,Projectile.TARGET_ENEMIES,_loc3_.x + _loc11_ / 2,_loc3_.y,0,- _loc4_);
         }
      }
   }
   function onRequestFireClusterBomb()
   {
      if(this.isExploding() || PlayerState(_global.getPlayerState()).getClusterBombsRemaining() <= 0)
      {
         return undefined;
      }
      if(AquaTeenGame(_global.g_kApplication.m_kGameScreen).getEnemyManager().isNoMoreEnemies())
      {
         return undefined;
      }
      var _loc8_ = this.getClipTime() - this.m_fLastClusterTime;
      if(_loc8_ > 1 / this.m_fFireRate)
      {
         var _loc4_ = {x:this._x,y:this._y};
         this._parent.localToGlobal(_loc4_);
         var _loc6_ = _loc4_.x / 3 - 100;
         _global.playSound("athf_clusterbomb_fire.wav",1,this,_loc6_);
         var _loc7_ = "s_ClusterBomb";
         var _loc9_ = Settings(_global.getSettings()).getSetting("PLAYER_FIRE_FORCE_" + PlayerState(_global.getPlayerState()).getLives());
         var _loc5_ = _global.g_kApplication.m_kGameScreen;
         var _loc10_ = this.getBounds(_loc5_);
         var _loc3_ = {x:this.m_kEmitPoint._x,y:this.m_kEmitPoint._y};
         this.localToGlobal(_loc3_);
         _loc5_.fireClusterBomb(_loc7_,Projectile.TARGET_ENEMIES,_loc3_.x,_loc3_.y,0,- _loc9_);
         PlayerState(_global.getPlayerState()).setClusterBombsRemaining(PlayerState(_global.getPlayerState()).getClusterBombsRemaining() - 1);
         this.m_fLastClusterTime = this.getClipTime();
         this.m_bFiring = true;
         this.m_bNormalAnimation = false;
         this.playAnimation("FIRE",70,61,90,false,1);
      }
   }
   function explode()
   {
      if(this.isExploding())
      {
         return undefined;
      }
      var _loc3_ = {x:this._x,y:this._y};
      this._parent.localToGlobal(_loc3_);
      var _loc4_ = _loc3_.x / 3 - 100;
      _global.playSound("athf_player_dies.wav",1,this,_loc4_);
      this.playAnimation("EXPLODE",30,11,60,false,1);
      this.m_bNormalAnimation = false;
      this.m_bExploding = true;
      this.onRequestStop();
   }
   function isExploding()
   {
      return this.m_bExploding;
   }
   function doEnterFrame()
   {
      if(ApplicationState(_global.getApplicationState()).isPaused())
      {
         return undefined;
      }
      var _loc6_ = this.getClipTime() - this.m_fLastUpdateTime;
      this.m_kController.update(_loc6_);
      this._x += this.m_fVelocityX * _loc6_;
      var _loc5_ = _global.g_kApplication.m_kGameScreen;
      var _loc3_ = this.getBounds(_loc5_);
      var _loc8_ = this._x - _loc3_.xMin;
      var _loc7_ = this._x - _loc3_.xMax;
      var _loc4_ = _loc5_.m_kPlayerHolder.m_kPlayerMarker.getBounds(_loc5_);
      if(_loc3_.xMin < _loc4_.xMin)
      {
         this._x = _loc4_.xMin + _loc8_;
      }
      else if(_loc3_.xMax > _loc4_.xMax)
      {
         this._x = _loc4_.xMax + _loc7_;
      }
      this.m_fLastUpdateTime = this.getClipTime();
   }
   function onActionCompleted(sActionKey)
   {
      if(sActionKey == "EXPLODE")
      {
         AquaTeenGame(_global.g_kApplication.m_kGameScreen).onPlayerDied();
      }
      else if(sActionKey == "FIRE")
      {
         this.m_bFiring = false;
         if(!this.m_bExploding)
         {
            if(this.getVelocityX() > 0)
            {
               this.playAnimation("WALK",30,91,120,true,1);
               this._xscale = Math.abs(this._xscale);
               this.m_bNormalAnimation = false;
            }
            else if(this.getVelocityX() < 0)
            {
               this.playAnimation("WALK",30,91,120,true,1);
               this._xscale = - Math.abs(this._xscale);
               this.m_bNormalAnimation = false;
            }
            else if(!this.m_bNormalAnimation)
            {
               this.playAnimation("NORMAL",8,1,10,true,1);
               this.m_bNormalAnimation = true;
            }
         }
      }
   }
}
