class Projectile extends LRG.LRGMovieClip
{
   var m_fVelocityX;
   var m_fVelocityY;
   var m_fTargetType;
   var m_fLastUpdateTime;
   static var TARGET_PLAYER = 0;
   static var TARGET_ENEMIES = 1;
   function Projectile()
   {
      super();
   }
   function init()
   {
      super.init();
      this.setClock(_global.getGameTimer());
      var _loc4_ = new Object();
      _loc4_.m_sName = "GENERIC";
      var _loc5_ = new LRG.LRGGenericAction(_loc4_);
      this.addAction(_loc5_);
      this.startAction("GENERIC",null,true);
      this.m_fVelocityX = 0;
      this.m_fVelocityY = 0;
      this.m_fTargetType = undefined;
      this.m_fLastUpdateTime = this.getClipTime();
   }
   function setVelocityX(fVel)
   {
      this.m_fVelocityX = fVel;
   }
   function getVelocityX()
   {
      return this.m_fVelocityX;
   }
   function setVelocityY(fVel)
   {
      this.m_fVelocityY = fVel;
   }
   function getVelocityY()
   {
      return this.m_fVelocityY;
   }
   function setTargetType(fTargetType)
   {
      this.m_fTargetType = fTargetType;
   }
   function getTargetType()
   {
      return this.m_fTargetType;
   }
   function collisionTest()
   {
      if(this.m_fTargetType == Projectile.TARGET_ENEMIES)
      {
         var _loc3_ = Enemy(AquaTeenGame(_global.g_kApplication.m_kGameScreen).getEnemyManager().checkCollision(this,false));
         if(_loc3_)
         {
            this.onImpact(_loc3_);
         }
      }
      else
      {
         var _loc4_ = AquaTeenGame(_global.g_kApplication.m_kGameScreen).getPlayer();
         if(_loc4_.hitTest(this._x,this._y,true))
         {
            this.onImpact(_loc4_);
         }
      }
   }
   function onImpact(kObject)
   {
      kObject.explode();
      AquaTeenGame(_global.g_kApplication.m_kGameScreen).onRequestRemoveProjectile(this);
   }
   function doEnterFrame()
   {
      if(ApplicationState(_global.getApplicationState()).isPaused())
      {
         return undefined;
      }
      var _loc4_ = this.getClipTime() - this.m_fLastUpdateTime;
      if(_loc4_ <= 0.03)
      {
         return undefined;
      }
      var _loc6_ = this.m_fVelocityX * _loc4_;
      var _loc5_ = this.m_fVelocityY * _loc4_;
      this._x += _loc6_;
      this._y += _loc5_;
      var _loc7_ = _global.g_kApplication.m_kGameScreen;
      var _loc3_ = this._parent.m_kBackground.getBounds(this._parent);
      if(this._x < _loc3_.xMin || this._x > _loc3_.xMax || this._y < _loc3_.yMin || this._y > _loc3_.yMax)
      {
         _loc7_.onRequestRemoveProjectile(this);
      }
      this.collisionTest();
      this.m_fLastUpdateTime = this.getClipTime();
   }
}
